unit VDRE_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, REDialogs, VBRegexp, Vcl.Menus, Vcl.ExtCtrls, Vcl.StdCtrls;

type

{ Susie Plugin API }

  //PictureInfo \
  PPictureInfo = ^TPictureInfo;
  TPictureInfo = record
    left: LongInt;
    top: LongInt;
    width: LongInt;
    height: LongInt;
    x_density: Word;
    y_density: Word;
    colorDepth: SmallInt;
    hInfo: HLOCAL;
  end;

  //ʊ֐
  TGetPluginInfo = function(infono: LongInt; buf: PAnsiChar; buflen: LongInt): Integer; stdcall;

  //o[W'00IN'̊֐
  TIsSupported = function(filename: PAnsiChar; dw: DWORD): Integer; stdcall;
  TGetPictureInfo = function(buf: PAnsiChar; len: LongInt;
    flag: Integer; var PictureInfo: TPictureInfo): Integer; stdcall;
  TGetPicture = function(buf: PAnsiChar; len: LongInt; flag: LongInt; var pHBInfo: HLOCAL;
    var pHBm: HLOCAL; lpPrgressCallback: Pointer; lData: LongInt): Integer; stdcall;
  TGetPreview = function(buf: PAnsiChar; len: LongInt; flag: Integer; var pHBInfo: HLOCAL;
    var pHBm: HLOCAL; lpPrgressCallback: Pointer; lData: LongInt): Integer; stdcall;

{ TMainForm }

  TMainForm = class(TForm)
    OpenDialog: TOpenDialog;
    FindDialog: TREFindDialog;
    Regexp: TVBRegexp;
    MainMenu: TMainMenu;
    FileMnu: TMenuItem;
    FileOpenMnu: TMenuItem;
    FileN1Mnu: TMenuItem;
    FileExitMnu: TMenuItem;
    EditMnu: TMenuItem;
    EditCopyMnu: TMenuItem;
    EditN1Mnu: TMenuItem;
    EditFindMnu: TMenuItem;
    EditFindPrevMnu: TMenuItem;
    EditFindNextMnu: TMenuItem;
    ViewMnu: TMenuItem;
    ViewAdjustWindowMnu: TMenuItem;
    ViewFullSizeMnu: TMenuItem;
    ViewN1Mnu: TMenuItem;
    ViewEncodeMnu: TMenuItem;
    ViewEncodeAutoMnu: TMenuItem;
    ViewEncodeN1Mnu: TMenuItem;
    ViewEncodeShiftJISMnu: TMenuItem;
    ViewEncodeUTF16Mnu: TMenuItem;
    ViewEncodeUTF16BEMnu: TMenuItem;
    ViewEncodeJISMnu: TMenuItem;
    ViewEncodeISO2022jpMnu: TMenuItem;
    ViewEncodeEUCJPMnu: TMenuItem;
    ViewEncodeUTF8Mnu: TMenuItem;
    ViewWordWrapMnu: TMenuItem;
    OptionMnu: TMenuItem;
    OptionConfigMnu: TMenuItem;
    ImageBox: TScrollBox;
    Image: TImage;
    Memo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure FileOpenMnuClick(Sender: TObject);
    procedure FileExitMnuClick(Sender: TObject);
    procedure EditMnuClick(Sender: TObject);
    procedure EditCopyMnuClick(Sender: TObject);
    procedure EditFindMnuClick(Sender: TObject);
    procedure EditFindPrevMnuClick(Sender: TObject);
    procedure EditFindNextMnuClick(Sender: TObject);
    procedure ViewStyleMnusClick(Sender: TObject);
    procedure ViewEncodeAutoMnuClick(Sender: TObject);
    procedure CodePageMnusClick(Sender: TObject);
    procedure ViewWordWrapMnuClick(Sender: TObject);
    procedure OptionConfigMnuClick(Sender: TObject);
    procedure MemoChange(Sender: TObject);
  private
    { Private 錾 }
    FMatches: TMatches;
    FPlugins: TStrings;	//'gq=ΉvOC'`̃XgB
    FPluginPath: string;
    FViewStyle: Integer;
    FTabStops: array[0..0] of DWORD;
    FCodePage: Cardinal;
    FModified: Boolean;
    FFileName: string;
    procedure SetPluginPath(Value: string);
    procedure SetViewStyle(Value: Integer);
    function GetTabWidth: Integer;
    procedure SetTabWidth(Value: Integer);
    function GetViewerFont: TFont;
    procedure SetViewerFont(Value: TFont);
    procedure SetCodePage(Value: Cardinal);
    procedure ReadOption;
    procedure WriteOption;
    function FillImage(FileName: string; MemoryStream: TMemoryStream;
      var Image: TBitmap): Boolean;
    function FillImageInfo(FileName: string; MemoryStream: TMemoryStream;
      var ImageInfo: TPictureInfo): Boolean;
    procedure DrawFullSize;
    procedure DrawAdjustWindow;
    function LoadImage(Filename: string; Stream: TMemoryStream): Boolean;
    procedure ShowCaretLine(Centering: Boolean);
    procedure LoadText(Filename: string; Stream: TMemoryStream; Code: Cardinal; Line, Digit: Integer);
    procedure LoadFile(Filename: string; Code: Cardinal; Line, Digit: Integer);
    procedure FindText;
  protected
    { protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WndProc(var Message: TMessage); override;
  public
    { Public 錾 }
    procedure InitPlugins(SearchPath: string);
    property PluginPath: string read FPluginPath write SetPluginPath;
    property ViewStyle: Integer read FViewStyle write SetViewStyle;
    property Plugins: TStrings read FPlugins write FPlugins;
    property TabWidth: Integer read GetTabWidth write SetTabWidth;
    property ViewerFont: TFont read GetViewerFont write SetViewerFont;
    property CodePage: Cardinal read FCodePage write SetCodePage;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  VDRE_Config,
  System.Types, System.UITypes, System.Win.Registry, System.StrUtils, System.IOUtils, AppData,
  Winapi.MLang, MLangUtils, Winapi.ShellAPI, Vcl.Clipbrd;

{ Susie Plugin API }

//Susie Plugin ŎgpR[obN֐Bnilł̂ǁB
function ProgressCallback(nNum, nDenom, lData: LongInt): Integer; stdcall;
begin
  Result := 0;
end;

{ TMainForm }

procedure TMainForm.SetPluginPath(Value: string);
begin
  if Value <> FPLuginPath then
  begin
    FPluginPath := Value;
    InitPlugins(FPluginPath);
    FModified := True;
  end;
end;

procedure TMainForm.SetViewStyle(Value: Integer);
begin
  if Value <> FViewStyle then
  begin
    FViewStyle := Value;
    case FViewStyle of
      1: ViewAdjustWindowMnu.Checked := True;
      2: ViewFullSizeMnu.Checked := True;
    end;
  end;
end;

function TMainForm.GetTabWidth: Integer;
begin
  Result := FTabStops[0] div 4;
end;

procedure TMainForm.SetTabWidth(Value: Integer);
begin
  if Value <> GetTabWidth then
  begin
    FTabStops[0] := 4 * Value;
    Memo.Perform(EM_SETTABSTOPS, 1, LPARAM(@FTabStops));
    FModified := True;
  end;
end;

function TMainForm.GetViewerFont: TFont;
begin
  Result := Memo.Font;
end;

procedure TMainForm.SetViewerFont(Value: TFont);
begin
  if Value <> Memo.Font then
  begin
    Memo.Font := Value;
    Memo.Perform(EM_SETTABSTOPS, 1, LPARAM(@FTabStops));
    FModified := True;
  end;
end;

procedure TMainForm.SetCodePage(Value: Cardinal);
begin
  if Value <> FCodePage then
  begin
    FCodePage := Value;
    case FCodePage of
      932: ViewEncodeShiftJISMnu.Checked := True;
      1200: ViewEncodeUTF16Mnu.Checked := True;
      1201: ViewEncodeUTF16BEMnu.Checked := True;
      20932: ViewEncodeJISMnu.Checked := True;
      50220: ViewEncodeISO2022jpMnu.Checked := True;
      51932: ViewEncodeEUCJPMnu.Checked := True;
      65001: ViewEncodeUTF8Mnu.Checked := True;
    else
      SetCodePage(DefaultSystemCodePage);
    end;
  end;
end;

procedure TMainForm.ReadOption;
var
  IniFile: TAppIniFile;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Videre\Videre.ini'));
  try
    PluginPath := IniFile.ReadString('Image', 'PluginPath', '');
    ViewStyle := IniFile.ReadInteger('Image', 'ViewStyle', 1);
    ViewWordWrapMnu.Checked := IniFile.ReadBool('Text', 'WordWrap', True);
    if ViewWordWrapMnu.Checked then
      Memo.ScrollBars := ssVertical
    else
      Memo.ScrollBars := ssBoth;
    TabWidth := IniFile.ReadInteger('Text', 'TabWidth', 4);
    ViewerFont.Name := IniFile.ReadString('Text', 'FontName', 'FixedSys');
    ViewerFont.Size := IniFile.ReadInteger('Text', 'FontSize', 9);
    ViewerFont.Style := TFontStyles(Byte(IniFile.ReadInteger('Text', 'FontStyle', 0)));
    ViewEncodeAutoMnu.Checked := IniFile.ReadBool('Text', 'AutoEncode', True);
    CodePage := Cardinal(IniFile.ReadInteger('Text', 'CodePage', DefaultSystemCodePage));
    ViewEncodeMnu.Enabled := SupportsMLang2;
  finally
    IniFile.Free;
  end;
  FModified := False;
end;

procedure TMainForm.WriteOption;
var
  IniFile: TAppIniFile;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\Videre\Videre.ini'));
  try
    IniFile.WriteString('Image', 'PluginPath', PluginPath);
    IniFile.WriteInteger('Image', 'ViewStyle', ViewStyle);
    IniFile.WriteBool('Text', 'WordWrap', ViewWordWrapMnu.Checked);
    IniFile.WriteInteger('Text', 'TabWidth', TabWidth);
    IniFile.WriteString('Text', 'FontName', ViewerFont.Name);
    IniFile.WriteInteger('Text', 'FontSize', ViewerFont.Size);
    IniFile.WriteInteger('Text', 'FontStyle', Byte(ViewerFont.Style));
    IniFile.WriteBool('Text', 'AutoEncode', ViewEncodeAutoMnu.Checked);
    IniFile.WriteInteger('Text', 'CodePage', Integer(CodePage));
  finally
    IniFile.Free;
  end;
  FModified :=False;
end;

function TMainForm.FillImage(FileName: string; MemoryStream: TMemoryStream;
  var Image: TBitmap): Boolean;
var
  Extension: string;
  PluginHnd: THandle;
  GetPicture: TGetPicture;
  HBitmapInfo, HBitmapBits: HLOCAL;
  BitmapInfo, BitmapBits: Pointer;
begin
  Result := False;
  if Image = nil then Exit;

  Extension := UpperCase(ExtractFileExt(FileName));
  if ('.BMP' = Extension) or ('.DIB' = Extension) then
  begin
    Image.LoadFromStream(MemoryStream);
    Result := True;
  end
  else
  begin
    PluginHnd := LoadLibrary(PChar(FPlugins.Values[Extension]));
    if PluginHnd <> 0 then
    begin
      @GetPicture := GetProcAddress(PluginHnd, 'GetPicture');
      if @GetPicture <> nil then
      begin
        Result := GetPicture(MemoryStream.Memory, MemoryStream.Size, 1,
          HBitmapInfo, HBitmapBits, @ProgressCallback, LongInt(Self)) = 0;
        if Result then
        begin
          BitmapInfo := LocalLock(HBitmapInfo);
          BitmapBits := LocalLock(HBitmapBits);
          with Image do
          begin
            Width := PBitmapInfo(BitmapInfo).bmiHeader.biWidth;
            Height := PBitmapInfo(BitmapInfo).bmiHeader.biHeight;
            SetDIBits(Canvas.Handle, Handle, 0, PBitmapInfo(BitmapInfo).bmiHeader.biHeight,
              BitmapBits, PBitmapInfo(BitmapInfo)^, DIB_RGB_COLORS);
          end;
          LocalUnLock(HBitmapInfo);
          LocalUnLock(HBitmapBits);
          LocalFree(HBitmapInfo);
          LocalFree(HBitmapBits);
        end;
      end;
      FreeLibrary(PluginHnd);
    end;
  end;
end;

function TMainForm.FillImageInfo(FileName: string; MemoryStream: TMemoryStream;
  var ImageInfo: TPictureInfo): Boolean;
var
  Extension: string;
  BitmapInfo: TBitmapInfoHeader;
  PluginHnd: THandle;
  GetPictureInfo: TGetPictureInfo;
begin
  Result := False;
  Extension := UpperCase(ExtractFileExt(FileName));
  if ('.BMP' = Extension) or ('.DIB' = Extension) then
  begin
    //rbg}bv̏ꍇAt@Cwb_ǂImageInfoݒB
    MemoryStream.Seek(SizeOf(TBitmapFileHeader), soFromBeginning);
    MemoryStream.ReadBuffer(BitmapInfo, SizeOf(TBitmapInfoHeader));
    with ImageInfo do
    begin
      left := 0;
      top := 0;
      width := BitmapInfo.biWidth;
      height := BitmapInfo.biHeight;
      x_density := BitmapInfo.biXPelsPerMeter;
      y_density := BitmapInfo.biYPelsPerMeter;
      colorDepth := BitmapInfo.biBitCount;
      hInfo := 0;
    end;
    Result := True;
  end
  else
  begin
    PluginHnd := LoadLibrary(PChar(FPlugins.Values[Extension]));
    if PluginHnd <> 0 then
    begin
      @GetPictureInfo := GetProcAddress(PluginHnd, 'GetPictureInfo');
      if @GetPictureInfo <> nil then
        Result := GetPictureInfo(MemoryStream.Memory, MemoryStream.Size, 1, ImageInfo) = 0;
      FreeLibrary(PluginHnd);
    end;
  end;
end;

procedure TMainForm.DrawFullSize;
begin
  with Image do
  begin
    AutoSize := True;
    Proportional := False;
    Width := Picture.Width;
    Height := Picture.Height;
  end;
end;

procedure TMainForm.DrawAdjustWindow;
begin
  with Image do
  begin
    AutoSize := False;
    Proportional := True;
    Width := ImageBox.ClientWidth;
    Height := ImageBox.ClientHeight;
  end;
end;

function TMainForm.LoadImage(Filename: string; Stream: TMemoryStream): Boolean;
var
  Bitmap: TBitmap;
  Rt: TRect;
  Info: TPictureInfo;
begin
  Memo.Hide;
  ImageBox.Show;

  Bitmap := TBitmap.Create;
  try
    Stream.Position := 0;
    Result := FillImage(Filename, Stream, Bitmap);
    if Result then
    begin
      Image.Picture.Assign(Bitmap);

      //EBhETCY̒B
      GetWindowRect(GetDesktopWindow, Rt);
      if PtInRect(Rt, ClientToScreen(Point(Image.Picture.Width, Image.Picture.Height))) then
      begin
        ClientWidth := Image.Picture.Width + (ImageBox.BevelWidth + 1) * 2;
        ClientHeight := Image.Picture.Height + (ImageBox.BevelWidth + 1) * 2;
      end;

      //t@C̓ǂݍ݁B
      if FillImageInfo(Filename, Stream, Info) then
      begin
        MainForm.Caption := Format('%s ( %d x %d %dbit ) - Videre', [
          ExtractFileName(Filename),
          Info.width,
          Info.height,
          Info.colorDepth
        ]);
      end
      else
        MainForm.Caption := Format('%s - Videre', [ExtractFileName(Filename)]);

      case ViewStyle of
        1: DrawAdjustWindow;
        2: DrawFullSize;
      end;
      ActiveControl := ImageBox;
    end;
  finally
    Bitmap.Free;
  end;
end;

procedure TMainForm.ShowCaretLine(Centering: Boolean);
var
  Rt: TRect;
  NowLine, ToLine: Integer;
begin
  //J[\sʂ̒ֈړB
  Memo.Perform(EM_GETRECT, 0, Longint(@Rt));
  Canvas.Font := Memo.Font;
  NowLine := Memo.Perform(EM_LINEFROMCHAR, UINT(-1), 0);
  if Centering then
  begin
    ToLine := Memo.Perform(EM_GETFIRSTVISIBLELINE, 0, 0) +
      ((Rt.Height div Canvas.TextHeight('H')) div 2) - 1;
  end
  else
   ToLine := 0;
  Memo.Perform(EM_LINESCROLL, 0, NowLine - ToLine);
end;

procedure TMainForm.LoadText(Filename: string; Stream: TMemoryStream; Code: Cardinal;
  Line, Digit: Integer);
var
  Rt: TRect;
  NewWidth, NewHeight: Integer;
  Encoding: TEncoding;
  Index: Integer;
  OldScrollBars: TScrollStyle;
begin
  ImageBox.Hide;
  Memo.Show;
  FreeAndNil(FMatches);

  //EBhETCY̒B
  GetWindowRect(GetDesktopWindow, Rt);
  if Rt.Right >= 1600 then
    NewWidth := Rt.Right div 2
  else
    NewWidth := Round(Rt.Right * 0.75);
  if Rt.Bottom >= 1200 then
    NewHeight := Rt.Bottom div 2
  else
    NewHeight := Round(Rt.Bottom * 0.75);
  if PtInRect(Rt, Point(Left + NewWidth, Top + NewHeight)) then
  begin
    Width := NewWidth;
    Height := NewHeight;
  end;

  //t@C̓ǂݍ݁B
  if Code <> 0 then
    CodePage := Code
  else if ViewEncodeAutoMnu.Checked then
    CodePage := DetectCodepage(MLDETECTCP_NONE, 0, Stream);
  Encoding := GetEncodingInstance(CodePage);
  try
    CodePage := Encoding.CodePage;
    MainForm.Caption := Format('%s ( %s ) - Videre', [
      ExtractFileName(Filename),
      GetEncodingName(CodePage)
    ]);
    Memo.Lines.LoadFromStream(Stream, Encoding);
    Memo.Perform(EM_SETTABSTOPS, 1, LPARAM(@FTabStops));
  finally
    Encoding.Free;
  end;

  if (Line > 1) or (Digit > 1) then
  begin
    Index := Digit - 1;
    OldScrollBars := Memo.ScrollBars;
    try
      Memo.ScrollBars := ssBoth;
      Memo.HandleNeeded;

      Inc(Index, Memo.Perform(EM_LINEINDEX, Line - 1, 0));
    finally
      Memo.ScrollBars := OldScrollBars;
      Memo.HandleNeeded;
    end;
    Memo.SelStart := Index;
    ShowCaretLine(False);
  end;
  ActiveControl := Memo;
end;

procedure TMainForm.LoadFile(Filename: string; Code: Cardinal; Line, Digit: Integer);
var
  Stream: TMemoryStream;
begin
  if Filename <> '' then
  begin
    FFileName := Filename;
    Stream := TMemoryStream.Create;
    try
      Stream.LoadFromFile(FFileName);
      if not LoadImage(FFileName, Stream) then
        LoadText(FFileName, Stream, Code, Line, Digit);
      ActiveControl.BringToFront; //hbvɂĂ Visible ̐ݒ肪fȂ̂ōŏIB

      Application.Title := FFileName + ' - Videre';
    finally
      Stream.Free;
    end;
  end;
end;

procedure TMainForm.FindText;
var
  s: string;
  Index, i: Integer;
begin
  if FindDialog.FindText = '' then
    EditFindMnu.Click
  else
  begin
    with Regexp do
    begin
      s := FindDialog.FindText;
      if frWholeWord in FindDialog.Options then
      begin
        if Usable and (frUsesRegexp in FindDialog.Options) then
          s := '(^|\b)' + s + '(\b|$)'
        else
          s := ' ' + s + ' ';
      end;
      if not Assigned(FMatches)
        or (Pattern <> s)
        or (IgnoreCase <> not (frMatchCase in FindDialog.Options))
        or (UsesRegexp <> (frUsesRegexp in FindDialog.Options))
        or (MultiLine <> (frMultiLine in FindDialog.Options)) then
      begin
        Pattern := s;
        IgnoreCase := not (frMatchCase in FindDialog.Options);
        UsesRegexp := frUsesRegexp in FindDialog.Options;
        MultiLine := frMultiLine in FindDialog.Options;

        if Assigned(FMatches) then
          FMatches.Free;
        FMatches := Execute(Memo.Text);
      end;
    end;

    Index := -1;
    if frDown in FindDialog.Options then
    begin
      for i := 0 to FMatches.Count - 1 do
        if FMatches.Items[i].FirstIndex > Memo.SelStart then
        begin
          Index := i;
          Break;
        end;
    end
    else
    begin
      for i := FMatches.Count - 1 downto 0 do
        if FMatches.Items[i].FirstIndex < Memo.SelStart then
        begin
          Index := i;
          Break;
        end;
    end;
    if Index > -1 then
    begin
      Memo.SelStart := FMatches.Items[Index].FirstIndex;
      Memo.SelLength := FMatches.Items[Index].Length;

      ShowCaretLine(True);
    end
    else
    begin
      //! MessageBeep(MB_ICONASTERISK);
      MessageDlg(Format(SUnfindString, [FindDialog.FindText]), mtInformation, [mbOK], 0);
    end;
  end;
end;

procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  //t@Chbv󂯓B
  Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

procedure TMainForm.WndProc(var Message: TMessage);
var
  FileName: array[0..MAX_PATH] of Char;
  i: Integer;
begin
  case Message.Msg of
    WM_MOUSEWHEEL:  //zC[CxgTScrollBoxŔȂ̂ŁAMainFormŏEB
    begin
      with ImageBox.VertScrollBar do
      begin
        if Visible then
        begin
          if SmallInt(HiWord(Message.WParam)) > 0 then
            Position := Position - Increment
          else
            Position := Position + Increment;
        end;
      end;
    end;
    WM_MOUSEHWHEEL: //zC[`gBCxg`Ȃ̂łŏEB
    begin
      with ImageBox.HorzScrollBar do
      begin
        if Visible then
        begin
          if SmallInt(HiWord(Message.WParam)) > 0 then
            Position := Position + Increment
          else
            Position := Position - Increment;
        end;
      end;
    end;
    WM_DROPFILES: //t@ChbvB
    begin
      ImageBox.Visible := False;
      Memo.Visible := False;
      DragQueryFile(Message.WParam, 0, FileName, SizeOf(FileName));
      try
        LoadFile(FileName, 0, 1, 1);
        for i := 1 to DragQueryFile(Message.WParam, $FFFFFFFF, FileName, SizeOf(FileName)) - 1 do
        begin
          DragQueryFile(Message.WParam, i, FileName, SizeOf(FileName));
          ShellExecute(Handle, 'open',
            PChar(ParamStr(0)), PChar(AnsiQuotedStr(FileName, '"')), '', SW_SHOWNORMAL);
        end;
      finally
        DragFinish(Message.WParam);
      end;
    end;
  end;

  inherited;
end;

procedure TMainForm.InitPlugins(SearchPath: string);
const
  Attr = faReadOnly + faSysFile + faArchive;
var
  Registry: TRegistry;
  s, Path, FileName: string;
  AnsiBuf: array[0..MAX_PATH] of AnsiChar;
  FindResult: Integer;
  SearchRec: TSearchRec;
  PluginHnd: THandle;
  GetPluginInfo: TGetPluginInfo;
begin
  FPlugins.Clear;
  FPlugins.Add('.bmp=');
  FPlugins.Add('.dib=');

  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    Registry.OpenKeyReadOnly('Software\Takechin\Susie\Plug-in');
    s := Registry.ReadString('Path');
  finally
    Registry.Free;
  end;

  s := Format('%s;%s;%s', [SearchPath, s, GetEnvironmentVariable('PATH')]);
  for Path in SplitString(s, ';') do
  begin
    FindResult := FindFirst(TPath.Combine(Path, '*.spi'), Attr, SearchRec);
    if FindResult = 0 then
    begin
      try
        repeat
          FileName := TPath.Combine(Path, SearchRec.Name);
          PluginHnd := LoadLibrary(PChar(FileName));
          if PluginHnd <> 0 then
          begin
            @GetPluginInfo := GetProcAddress(PluginHnd, 'GetPluginInfo');
            if @GetPluginInfo <> nil then
            begin
              GetPluginInfo(0, AnsiBuf, MAX_PATH);
              if AnsiBuf = '00IN' then
              begin
                GetPluginInfo(2, AnsiBuf, MAX_PATH);
                for s in SplitString(StringReplace(string(AnsiBuf), '*', '', [rfReplaceAll]), ';') do
                  FPlugins.Add(UpperCase(s) + '=' + FileName);
              end;
            end;
            FreeLibrary(PluginHnd);
          end;
          FindResult := FindNext(SearchRec);
        until FindResult <> 0;
      finally
        FindClose(SearchRec);
      end;
      Break;
    end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i, Line, Digit: Integer;
  Code: Cardinal;
  Param: string;
begin
  FMatches := nil;
  FPlugins := TStringList.Create;
  ReadOption;

  ImageBox.Align := alClient;
  Memo.Align := alClient;
  if not Regexp.Usable then
    FindDialog.Options := FindDialog.Options - [frUsesRegexp] + [frDisableUsesRegexp];

  Code := 0;
  Line := 1;
  Digit := 1;
  for i := 1 to ParamCount do
  begin
    if CharInSet(ParamStr(i)[1], ['-', '/']) then
    begin
      case ParamStr(i)[2] of
        'c', 'C': Code := StrToUIntDef(Copy(ParamStr(i), 3, Length(ParamStr(i))), 0);
        'l', 'L': Line := StrToIntDef(Copy(ParamStr(i), 3, Length(ParamStr(i))), 1);
        'd', 'D': Digit := StrToIntDef(Copy(ParamStr(i), 3, Length(ParamStr(i))), 1);
      end;
    end
    else
    begin
      if FFileName = '' then
        LoadFile(ParamStr(i), Code, Line, Digit)
      else
      begin
        Param := Format('/C%d /L%d /D%d %s', [Code, Line, Digit, AnsiQuotedStr(ParamStr(i), '"')]);
        ShellExecute(Handle, 'open', PChar(ParamStr(0)), PChar(Param), '', SW_SHOWNORMAL);
      end;
      Code := 0;
      Line := 1;
      Digit := 1;
    end;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  if FModified then
    WriteOption;

  if Assigned(FMatches) then
    FMatches.Free;
  FPlugins.Free;
end;

procedure TMainForm.FindDialogFind(Sender: TObject);
begin
  FindText;
end;

procedure TMainForm.FileOpenMnuClick(Sender: TObject);
begin
  if OpenDialog.Execute then
    LoadFile(OpenDialog.FileName, 0, 1, 1);
end;

procedure TMainForm.FileExitMnuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditMnuClick(Sender: TObject);
begin
  if ImageBox.Visible then
  begin
    EditCopyMnu.Enabled := True;
    EditFindMnu.Enabled := False;
    EditFindPrevMnu.Enabled := False;
    EditFindNextMnu.Enabled := False;
  end
  else if Memo.Visible then
  begin
    EditCopyMnu.Enabled := Memo.SelText <> '';
    EditFindMnu.Enabled := True;
    EditFindPrevMnu.Enabled := True;
    EditFindNextMnu.Enabled := True;
  end
  else
  begin
    EditCopyMnu.Enabled := False;
    EditFindMnu.Enabled := False;
    EditFindPrevMnu.Enabled := False;
    EditFindNextMnu.Enabled := False;
  end;
end;

procedure TMainForm.EditCopyMnuClick(Sender: TObject);
begin
  if ImageBox.Visible then
    Clipboard.Assign(Image.Picture)
  else if Memo.Visible then
    Memo.CopyToClipboard;
end;

procedure TMainForm.EditFindMnuClick(Sender: TObject);
begin
  FindDialog.Execute;
end;

procedure TMainForm.EditFindPrevMnuClick(Sender: TObject);
begin
  FindDialog.Options := FindDialog.Options - [frDown];
  FindText;
end;

procedure TMainForm.EditFindNextMnuClick(Sender: TObject);
begin
  FindDialog.Options := FindDialog.Options + [frDown];
  FindText;
end;

procedure TMainForm.ViewStyleMnusClick(Sender: TObject);
var
  Item: TMenuItem;
begin
  Item := Sender as TMenuItem;
  Item.Checked := True;
  ViewStyle := Item.Tag;
  case ViewStyle of
    1: DrawAdjustWindow;
    2: DrawFullSize;
  end;
  FModified := True;
end;

procedure TMainForm.ViewEncodeAutoMnuClick(Sender: TObject);
begin
  FModified := True;
end;

procedure TMainForm.CodePageMnusClick(Sender: TObject);
var
  OldStart, OldLength: Integer;
begin
  with TMenuItem(Sender) do
    if CodePage <> NativeUInt(Tag) then
    begin
      Checked := True;
      CodePage := Tag;

      if Memo.Visible then
      begin
        OldStart := Memo.SelStart;
        OldLength := Memo.SelLength;

        LoadFile(FFileName, CodePage, 1, 1);

        Memo.SelStart := OldStart;
        Memo.SelLength := OldLength;
        ShowCaretLine(False);
      end;
      FModified := True;
    end;
end;

procedure TMainForm.ViewWordWrapMnuClick(Sender: TObject);
begin
  //WordWrap ݒ肵ȂĂAScrollBars ̕ύXł݂B
  if ViewWordWrapMnu.Checked then
    Memo.ScrollBars := ssVertical
  else
    Memo.ScrollBars := ssBoth;
  Memo.HandleNeeded;  //ScrollBars ςƃnĥō蒼B
  ShowCaretLine(False);

  FModified := True;
end;

procedure TMainForm.OptionConfigMnuClick(Sender: TObject);
begin
  ConfigDialog.ShowModal;
end;

procedure TMainForm.MemoChange(Sender: TObject);
begin
  if Memo.Modified then
  begin
    FreeAndNil(FMatches);
    Memo.Modified := False;
  end;
end;

end.
