(* MLangUtils

Ver, 1.00 2016/09/17 DetectCodepage, GetEncodingInstance B
Ver, 1.01 2017/08/19 SupportsMLang2 ǉB
Ver, 1.02 2018/11/22 וB
Ver, 1.03 2023/06/01 DetectCodepage(TStream) ύXBGetCodePage ǉBGetEncodingInstance I[o[[hB

Winapi.MLang ֘A[eBWB
ǉꂽ񂾂HMultiLanguage_TLB Ƃ͎dlႤ݂ǁB
pɂ Internet Explorer 5 ȍ~KvB

   R[h[eBeBW *)

unit MLangUtils;

interface

uses
  System.SysUtils, System.Classes, Winapi.Windows, Winapi.ActiveX, Winapi.MLang;

type
  { Winapi.MLang.IMultiLanguage2 C }

  {$HPPEMIT 'DECLARE_DINTERFACE_TYPE(IMultiLanguage2);'}
  IMultiLanguage2 = interface(IUnknown)
    [SID_IMultiLanguage2]
    function GetNumberOfCodePageInfo(out pcCodePage: UINT): HResult; stdcall;
    function GetCodePageInfo(uiCodePage: UINT; LangId: Word; out pCodePageInfo: tagMIMECPINFO)
      : HResult; stdcall;
    function GetFamilyCodePage(uiCodePage: UINT; out puiFamilyCodePage: UINT)
      : HResult; stdcall;
    function EnumCodePages(grfFlags: LongWord; LangId: Word; out ppEnumCodePage: IEnumCodePage)
      : HResult; stdcall;
    function GetCharsetInfo(const Charset: WideString; out pCharsetInfo: tagMIMECSETINFO)
      : HResult; stdcall;
    function IsConvertible(dwSrcEncoding: LongWord; dwDstEncoding: LongWord): HResult; stdcall;
    function ConvertString(var pdwMode: LongWord; dwSrcEncoding: LongWord; dwDstEncoding: LongWord;
      pSrcStr: Pointer; pcSrcSize: PUINT; pDstStr: Pointer; var pcDstSize: UINT)
      : HResult; stdcall;
    function ConvertStringToUnicode(var pdwMode: LongWord; dwEncoding: LongWord;
      pSrcStr: Pointer; pcSrcSize: PUINT; pDstStr: PWideChar; var pcDstSize: UINT)
      : HResult; stdcall;
    function ConvertStringFromUnicode(var pdwMode: LongWord; dwEncoding: LongWord;
      pSrcStr: PWideChar; pcSrcSize: PUINT; pDstStr: Pointer; var pcDstSize: UINT)
      : HResult; stdcall;
    function ConvertStringReset: HResult; stdcall;
    function GetRfc1766FromLcid(locale: LongWord; out pbstrRfc1766: WideString): HResult; stdcall;
    function GetLcidFromRfc1766(out plocale: LongWord; const bstrRfc1766: WideString)
      : HResult; stdcall;
    function EnumRfc1766(LangId: Word; out ppEnumRfc1766: IEnumRfc1766): HResult; stdcall;
    function GetRfc1766Info(locale: LongWord; LangId: Word; out pRfc1766Info: tagRFC1766INFO)
      : HResult; stdcall;
    function CreateConvertCharset(uiSrcCodePage: UINT; uiDstCodePage: UINT;
      dwProperty: LongWord; out ppMLangConvertCharset: IMLangConvertCharset): HResult; stdcall;
    function ConvertStringInIStream(var pdwMode: LongWord; dwFlag: LongWord; lpFallBack: PWideChar;
      dwSrcEncoding: LongWord; dwDstEncoding: LongWord; const [ref] pstmIn: IStream;
      const [ref] pstmOut: IStream): HResult; stdcall;
    function ConvertStringToUnicodeEx(var pdwMode: LongWord; dwEncoding: LongWord;
      pSrcStr: Pointer; pcSrcSize: PUINT; pDstStr: PWideChar; var pcDstSize: UINT;
      dwFlag: LongWord; lpFallBack: PWideChar): HResult; stdcall;
    function ConvertStringFromUnicodeEx(var pdwMode: LongWord; dwEncoding: LongWord;
      pSrcStr: PWideChar; pcSrcSize: PUINT; pDstStr: Pointer; var pcDstSize: UINT;
      dwFlag: LongWord; lpFallBack: PWideChar): HResult; stdcall;
    function DetectCodepageInIStream(dwFlag: LongWord; dwPrefWinCodePage: LongWord;
      const {[ref]} pstmIn: IStream; lpEncoding: PDetectEncodingInfo; var pnScores: Integer)
      : HResult; stdcall; //[ref] tĂƃANZXᔽNB
   function DetectInputCodepage(dwFlag: LongWord; dwPrefWinCodePage: LongWord;
      pSrcStr: Pointer; var pcSrcSize: Integer; lpEncoding: PDetectEncodingInfo;
      var pnScores: Integer): HResult; stdcall;
    function ValidateCodePage(uiCodePage: UINT; hwnd: HWND): HResult; stdcall;
    function GetCodePageDescription(uiCodePage: UINT; lcid: LongWord; lpWideCharStr: PWideChar;
      cchWideChar: Integer): HResult; stdcall;
    function IsCodePageInstallable(uiCodePage: UINT): HResult; stdcall;
    function SetMimeDBSource(dwSource: UINT): HResult; stdcall;
    function GetNumberOfScripts(out pnScripts: UINT): HResult; stdcall;
    function EnumScripts(dwFlags: LongWord; LangId: Word; out ppEnumScript: IEnumScript)
      : HResult; stdcall;
    function ValidateCodePageEx(uiCodePage: UINT; hwnd: HWND;
      dwfIODControl: LongWord): HResult; stdcall;
  end;

function SupportsMLang2: Boolean;
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStr: Pointer; SrcSize: Integer): Cardinal; overload;
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStream: TStream): Cardinal; overload;
function GetEncodingName(CodePage: Cardinal): string;
function GetCodePage(EncodingName: string): Cardinal;
function GetEncodingInstance(CodePage: Cardinal): TEncoding; overload;
function GetEncodingInstance(EncodingName: string): TEncoding; overload;

implementation

uses
  System.Win.ComObj, Vcl.AxCtrls;

{ MLang.dll  IMultiLanguage2 g邩ׂ }
function SupportsMLang2: Boolean;
var
  MLang: IUnknown;
begin
  MLang := CreateComObject(CLSID_CMultiLanguage);
  Result := Supports(MLang, IID_IMultiLanguage2);
end;

{ R[hy[W𒲂ׂ
@pnScores = 1  lpEncoding.nCodePage Ԃق DetectInputCodepage Ɠ }
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStr: Pointer; SrcSize: Integer): Cardinal;
var
  MLang2: IMultiLanguage2;
  Scores: Integer;
  Encoding: TDetectEncodingInfo;
begin
  Result := $FFFFFFFF;

  CoInitialize(nil);  //XbhŎgꍇ͌ĂяoȂƂȂȂ݂B
  try
    MLang2 := CoCMultiLanguage.Create as IMultiLanguage2;
    if Assigned(MLang2) then
    begin
      Scores := 1;
      if MLang2.DetectInputCodepage(Flag, CodePage, SrcStr, SrcSize, @Encoding, Scores) = S_OK then
        Result := Encoding.nCodePage;
    end;
  finally
    CoUninitialize;
  end;
end;

{ R[hy[W𒲂ׂ
@pnScores = 1  pstmIn ̌^ TStream ɂȂA
@lpEncoding.nCodePage Ԃق DetectCodepageInIStream Ɠ }
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStream: TStream): Cardinal;
var
  MLang2: IMultiLanguage2;
  OrgPos: Int64;
  Buffer: IStream;
  Scores: Integer;
  Encoding: TDetectEncodingInfo;
begin
  Result := $FFFFFFFF;

  CoInitialize(nil);
  try
    MLang2 := CoCMultiLanguage.Create as IMultiLanguage2;
    if Assigned(MLang2) then
    begin
      OrgPos := SrcStream.Position;

      Buffer := TStreamAdapter.Create(SrcStream) as IStream;
      Scores := 1;
      if MLang2.DetectCodepageInIStream(Flag, CodePage, Buffer, @Encoding, Scores) = S_OK then
        Result := Encoding.nCodePage;

      SrcStream.Position := OrgPos;
    end;
  finally
    CoUninitialize;
  end;
end;
{! Ver,1.02 ܂ł DetectCodepageInIStream gȂ@B
var
  SavedPos: Int64;
  SrcStr: array of Char;
  SrcSize: SYSINT;
begin
  SavedPos := SrcStream.Position;
  try
    SrcStream.Position := 0;
    SrcSize := SrcStream.Size;
    SetLength(SrcStr, SrcSize);
    SrcStream.Read(SrcStr[0], Length(SrcStr));

    Result := DetectCodepage(Flag, CodePage, @SrcStr[0], SrcSize);
  finally
    SrcStream.Position := SavedPos;
  end;
end; !}

{ CodePage R[hy[Ŵ̖𓾂
@͓̎̂Ǝ`B`̏ꍇ͔ԍ̂܂ܕԂ
  System.SysUtils.GetEncodingNameFromCodePage Ă̂ implementation ȉɂ邯 }
function GetEncodingName(CodePage: Cardinal): string;
begin
  case CodePage of
    0:     Result := GetEncodingName(DefaultSystemCodePage);
    932:   Result := 'Shift-JIS';
    1200:  Result := 'UTF-16';
    1201:  Result := 'UTF-16BE';
    1252:  Result := 'Latin-ANSI';
    12000: Result := 'UTF-32';
    12001: Result := 'UTF-32BE';
    20127: Result := 'US-ASCII';
    20932: Result := 'JIS';
    50220: Result := 'iso-2022-jp';
    51932: Result := 'EUC-JP';
    65001: Result := 'UTF-8';
  else
    Result := UIntToStr(CodePage);
  end;
end;

{ EncodingName R[hy[W𓾂
@͓̎̂Ǝ`B`̏ꍇ̓[Ԃ
  System.SysUtils.GetCodePageFromEncodingName Ă̂ implementation ȉɂ邯 }
function GetCodePage(EncodingName: string): Cardinal;
begin
  if SameText(EncodingName, 'Shift-JIS') then Result := 932
  else
  if SameText(EncodingName, 'UTF-16') then Result := 1200
  else
  if SameText(EncodingName, 'UTF-16BE') then Result := 1201
  else
  if SameText(EncodingName, 'Latin-ANSI') then Result := 1252
  else
  if SameText(EncodingName, 'UTF-32') then Result := 12000
  else
  if SameText(EncodingName, 'UTF-32BE') then Result := 12001
  else
  if SameText(EncodingName, 'US-ASCII') then Result := 20127
  else
  if SameText(EncodingName, 'JIS') then Result := 20932
  else
  if SameText(EncodingName, 'iso-2022-jp') then Result := 50220
  else
  if SameText(EncodingName, 'EUC-JP') then Result := 51932
  else
  if SameText(EncodingName, 'UTF-8') then Result := 65001
  else
    Result := 0;
end;

{ CodePage  TEncoding 𓾂
@T|[g̏ꍇ̓ftHg̃GR[hԂ }
function GetEncodingInstance(CodePage: Cardinal): TEncoding;
begin
  case CodePage of
    932:   Result := TMBCSEncoding.Create(932);         //Shift-JIS
    1200:  Result := TUnicodeEncoding.Create;           //UTF-16
    1201:  Result := TBigEndianUnicodeEncoding.Create;  //UTF-16BE
    20932: Result := TMBCSEncoding.Create(20932);       //JIS-0208-1990 and 0121-1990
    50220: Result := TMBCSEncoding.Create(50220);       //iso-2022-jp
    51932: Result := TMBCSEncoding.Create(20932);       //EUC-JP
    65001: Result := TMBCSEncoding.Create(65001);       //UTF-8 BOM͋ʂȂ炵B
    //12000: Result := ;  //UTF-32 TEncodingł͖T|[gB
    //12001: Result := ;  //UTF-32BE TEncodingł͖T|[gB
  else
    Result := TMBCSEncoding.Create(DefaultSystemCodePage);
  end;
end;

{ EncodingName  TEncoding 𓾂
@T|[g̏ꍇ̓ftHg̃GR[hԂ }
function GetEncodingInstance(EncodingName: string): TEncoding;
begin
  Result := GetEncodingInstance(GetCodePage(EncodingName));
end;

end.
