(* TREFindDialog, TREReplaceDialog

Ver, 1.00 2006/11/22 ^B
Ver, 1.01 2011/11/05 THistoryBox ̗p~B
Ver, 1.02 2014/02/18 frFindNext ̕ύXBOnShow, OnClose CxgǉBقAוCB
Ver, 1.03 2014/09/30 Execute  TFindDialog ɂ킹B
Ver, 1.04 2014/10/01 |J~XCBłɁAĔh~B
Ver, 1.05 2016/08/16 Execute ̏CB
Ver, 1.06 2018/08/22 Delphi10.1 ΉB
Ver, 1.07 2023/03/14 Delphi10.4 ɈڍsBs[hΉBוB

[K\gp] `FbN{bNX̕tEu_CAOB

vpeB
Options;    _CAO{bNX̊OςƓB
            frFindNext IvV́A_CAǑEuύXۂɂB

Cxg
OnReplace;    muĎɁn{^NbNƂɔB
OnReplaceAll; mׂĒun{^NbNƂɔB

LȊÕvpeBA\bhACxg TFindDialog/TReplaceDialog ƓB

  K\Eu_CAO{bNX *)

unit REDialogs;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TREFindOption = (
    frDown, frFindNext, frHideMatchCase, frHideWholeWord, frHideUpDown,
    frMatchCase, frDisableMatchCase, frDisableUpDown, frDisableWholeWord,
    frReplace, frReplaceAll, frWholeWord, frShowHelp,  //܂ł TFindOption ƓB
    frHideUsesRegexp,     //[K\gp] `FbN{bNX폜B
    frDisableUsesRegexp,  //[K\gp] `FbN{bNX𖳌ɂB
    frUsesRegexp,         //K\gpB
    frHideMultiLine,      //[s[h] `FbN{bNX폜B
    frDisableMultiLine,   //[s[h] `FbN{bNX𖳌ɂB
    frMultiLine           //s[hB
  );
  TREFindOptions = set of TREFindOption;

  TDialogStyle = (dsFind, dsReplace);

  TREDialogForm = class(TForm)
    FindTextPnl: TPanel;
    FindTextLbl: TLabel;
    FindTextEdt: TEdit;
    ReplaceTextPnl: TPanel;
    PeplaceTextLbl: TLabel;
    ReplaceTextEdt: TEdit;
    OptionsPnl: TPanel;
    WholeWordChk: TCheckBox;
    MatchCaseChk: TCheckBox;
    OptionsExPnl: TPanel;
    UsesRegexpChk: TCheckBox;
    MultiLineChk: TCheckBox;
    DirectionPnl: TPanel;
    DirectionRgp: TRadioGroup;
    FindPnl: TPanel;
    FindBtn: TButton;
    ReplacePnl: TPanel;
    ReplaceBtn: TButton;
    ReplaceAllBtn: TButton;
    CanselPnl: TPanel;
    CancelBtn: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    FDialogStyle: TDialogStyle;
    procedure SetDialogStyle(Value: TDialogStyle);
  public
    { Public 錾 }
    property DialogStyle: TDialogStyle read FDialogStyle write SetDialogStyle;
  end;

  TREFindDialog = class(TComponent)
  private
    { Private 錾 }
    FDialog: TREDialogForm;
    FLayout: TDialogStyle;
    FPosition: TPoint;
    FOptions: TREFindOptions;
    FExecute: TREFindOptions;
    FFindText: string;
    FReplaceText: string;
    FOnShow: TNotifyEvent;
    FOnFind: TNotifyEvent;
    FOnReplace: TNotifyEvent;
    FOnReplaceAll: TNotifyEvent;
    FOnClose: TNotifyEvent;
    function GetPosition: TPoint;
    procedure SetPosition(const Value: TPoint);
    function GetLeft: Integer;
    procedure SetLeft(Value: Integer);
    function GetTop: Integer;
    procedure SetTop(Value: Integer);
    function GetOptions: TREFindOptions;
    procedure SetOptions(const Value: TREFindOptions);
    function GetFindText: string;
    procedure SetFindText(const Value: string);
    function GetReplaceText: string;
    procedure SetReplaceText(const Value: string);
    property ReplaceText: string read GetReplaceText write SetReplaceText;
    property OnReplace: TNotifyEvent read FOnReplace write FOnReplace;
    property OnReplaceAll: TNotifyEvent read FOnReplaceAll write FOnReplaceAll;
  protected
    { Protected 錾 }
    procedure FindTextEdtChange(Sender: TObject);
    procedure ReplaceTextEdtChange(Sender: TObject);
    property Layout: TDialogStyle read FLayout write FLayout;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Find(Sender: TObject);
    procedure Replace(Sender: TObject);
    procedure ReplaceAll(Sender: TObject);
    procedure Cansel(Sender: TObject);
    function Execute: Boolean;
    procedure CloseDialog;
    property Position: TPoint read GetPosition write SetPosition;
    property Left: Integer read GetLeft write SetLeft;
    property Top: Integer read GetTop write SetTop;
  published
    { Published 錾 }
    property Options: TREFindOptions
      read GetOptions write SetOptions default [frDown, frUsesRegexp];
    property FindText: string read GetFindText write SetFindText;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
    property OnFind: TNotifyEvent read FOnFind write FOnFind;
    property OnClose: TNotifyEvent read FOnClose write FOnClose;
  end;

  TREReplaceDialog = class(TREFindDialog)
  private
    { Private 錾 }
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property ReplaceText;
    property OnReplace;
    property OnReplaceAll;
  end;

procedure Register;

var
  REDialogForm: TREDialogForm;

implementation

{$R *.dfm}

uses
  System.Types;

resourcestring
  SFindCaption = '';
  SReplaceCaption = 'u';

{ TREDialogForm }

procedure TREDialogForm.SetDialogStyle(Value: TDialogStyle);
var
  OptionsHeight, ButtonsHeight: Integer;
begin
  FDialogStyle := Value;
  case FDialogStyle of
    dsFind:
    begin
      Caption := SFindCaption;
      ReplaceTextPnl.Visible := False;
      OptionsPnl.Top := FindTextPnl.Top + FindTextPnl.Height;
      OptionsExPnl.Top := OptionsPnl.Top + OptionsPnl.Height;
      OptionsExPnl.Visible := UsesRegexpChk.Visible;
      DirectionPnl.Top := OptionsPnl.Top;
      ReplacePnl.Visible := False;
      CanselPnl.Top := FindPnl.Top + FindPnl.Height;
    end;
    dsReplace:
    begin
      Caption := SReplaceCaption;
      ReplaceTextPnl.Visible := True;
      OptionsPnl.Top := ReplaceTextPnl.Top + ReplaceTextPnl.Height;
      OptionsExPnl.Top := OptionsPnl.Top + OptionsPnl.Height;
      OptionsExPnl.Visible := UsesRegexpChk.Visible;
      DirectionPnl.Top := OptionsPnl.Top;
      ReplacePnl.Visible := True;
      CanselPnl.Top := ReplacePnl.Top + ReplacePnl.Height;
    end;
  end;
  if OptionsExPnl.Visible then
    OptionsHeight := OptionsExPnl.Top + OptionsExPnl.Height
  else
    OptionsHeight := OptionsPnl.Top + OptionsPnl.Height;
  ButtonsHeight := CanselPnl.Top + CanselPnl.Height;
  if OptionsHeight > ButtonsHeight then
    ClientHeight := OptionsHeight
  else
    ClientHeight := ButtonsHeight;
end;

procedure TREDialogForm.FormCreate(Sender: TObject);
begin
  FDialogStyle := dsReplace;
end;

{ TREFindDialog }

function TREFindDialog.GetPosition: TPoint;
begin
  Result := FPosition;
  if Assigned(FDialog) then
    Result := Point(FDialog.Left, FDialog.Top);
end;

procedure TREFindDialog.SetPosition(const Value: TPoint);
begin
  if (FPosition.X <> Value.X) or (FPosition.Y <> Value.Y) then
  begin
    FPosition := Value;
    if Assigned(FDialog) then
    begin
      FDialog.Left := FPosition.X;
      FDialog.Top := FPosition.Y;
    end;
  end;
end;

function TREFindDialog.GetLeft: Integer;
begin
  Result := Position.X;
end;

procedure TREFindDialog.SetLeft(Value: Integer);
begin
  SetPosition(Point(Value, Top));
end;

function TREFindDialog.GetTop: Integer;
begin
  Result := Position.Y;
end;

procedure TREFindDialog.SetTop(Value: Integer);
begin
  SetPosition(Point(Left, Value));
end;

function TREFindDialog.GetOptions: TREFindOptions;
begin
  Result := FOptions;
  if Assigned(FDialog) then
  begin
    Result := FExecute;
    with FDialog do
    begin
      if not WholeWordChk.Enabled then Include(Result, frDisableWholeWord);
      if not WholeWordChk.Visible then Include(Result, frHideWholeWord);
      if WholeWordChk.Checked then Include(Result, frWholeWord);

      if not MatchCaseChk.Enabled then Include(Result, frDisableMatchCase);
      if not MatchCaseChk.Visible then Include(Result, frHideMatchCase);
      if MatchCaseChk.Checked then Include(Result, frMatchCase);

      if not UsesRegexpChk.Enabled then Include(Result, frDisableUsesRegexp);
      if not UsesRegexpChk.Visible then Include(Result, frHideUsesRegexp);
      if UsesRegexpChk.Checked then Include(Result, frUsesRegexp);

      if not MultiLineChk.Enabled then Include(Result, frDisableMultiLine);
      if not MultiLineChk.Visible then Include(Result, frHideMultiLine);
      if MultiLineChk.Checked then Include(Result, frMultiLine);

      if not DirectionRgp.Enabled then Include(Result, frDisableUpDown);
      if not DirectionRgp.Visible then Include(Result, frHideUpDown);
      if DirectionRgp.ItemIndex = 1 then Include(Result, frDown);
    end;
  end;
end;

procedure TREFindDialog.SetOptions(const Value: TREFindOptions);
begin
  FOptions := Value;
  if Assigned(FDialog) then
  begin
    with FDialog do
    begin
      WholeWordChk.Enabled := not (frDisableWholeWord in FOptions);
      WholeWordChk.Visible := not (frHideWholeWord in FOptions);
      WholeWordChk.Checked := frWholeWord in FOptions;

      MatchCaseChk.Enabled := not (frDisableMatchCase in FOptions);
      MatchCaseChk.Visible := not (frHideMatchCase in FOptions);
      MatchCaseChk.Checked := frMatchCase in FOptions;

      UsesRegexpChk.Enabled := not (frDisableUsesRegexp in FOptions);
      UsesRegexpChk.Visible := not (frHideUsesRegexp in FOptions);
      UsesRegexpChk.Checked := frUsesRegexp in FOptions;

      MultiLineChk.Enabled := not (frDisableMultiLine in FOptions);
      MultiLineChk.Visible := not (frHideMultiLine in FOptions);
      MultiLineChk.Checked := frMultiLine in FOptions;

      DirectionRgp.Enabled := not (frDisableUpDown in FOptions);
      DirectionRgp.Visible := not (frHideUpDown in FOptions);
      DirectionRgp.ItemIndex := Ord(frDown in FOptions);
    end;
  end;
end;

function TREFindDialog.GetFindText: string;
begin
  Result := FFindText;
  if Assigned(FDialog) then
    Result := FDialog.FindTextEdt.Text;
end;

procedure TREFindDialog.SetFindText(const Value: string);
begin
  FFindText := Value;
  if Assigned(FDialog) then
    FDialog.FindTextEdt.Text := FFindText;
end;

function TREFindDialog.GetReplaceText: string;
begin
  Result := FReplaceText;
  if Assigned(FDialog) then
    Result := FDialog.ReplaceTextEdt.Text;
end;

procedure TREFindDialog.SetReplaceText(const Value: string);
begin
  FReplaceText := Value;
  if Assigned(FDialog) then
    FDialog.ReplaceTextEdt.Text := FReplaceText;
end;

procedure TREFindDialog.FindTextEdtChange(Sender: TObject);
var
  Selectable: Boolean;
begin
  Selectable := FDialog.FindTextEdt.Text <> '';
  with FDialog do
  begin
    FindBtn.Enabled := Selectable;
    ReplaceBtn.Enabled := Selectable;
    ReplaceAllBtn.Enabled := Selectable;
  end;
  FExecute := FExecute - [frFindNext];
end;

procedure TREFindDialog.ReplaceTextEdtChange(Sender: TObject);
begin
  FExecute := FExecute - [frFindNext];
end;

constructor TREFindDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FLayout := dsFind;
  FPosition.X := -1;
  FPosition.Y := -1;
  FOptions := [frDown, frUsesRegexp];
  FExecute := [];
end;

destructor TREFindDialog.Destroy;
begin
  inherited Destroy;
end;

procedure TREFindDialog.Find(Sender: TObject);
begin
  FExecute := [frFindNext];
  if Assigned(FOnFind) then FOnFind(Sender);
end;

procedure TREFindDialog.Replace(Sender: TObject);
begin
  FExecute := FExecute + [frReplace];
  if Assigned(FOnReplace) then FOnReplace(Sender);
end;

procedure TREFindDialog.ReplaceAll(Sender: TObject);
begin
  FExecute := FExecute + [frReplaceAll];
  if Assigned(FOnReplaceAll) then FOnReplaceAll(Sender);
end;

procedure TREFindDialog.Cansel(Sender: TObject);
begin
  FExecute := [];
  FDialog.Hide;
end;

function TREFindDialog.Execute: Boolean;
begin
  if not Assigned(FDialog) then
  begin
    if (FPosition.X < 0) and (FPosition.Y < 0) then
      FPosition := Application.MainForm.ClientOrigin;
    FDialog := TREDialogForm.Create(Application);
    SetOptions(FOptions);
    with FDialog do
    begin
      Left := FPosition.X;
      Top := FPosition.Y;
      FindTextEdt.Text := FFindText;
      ReplaceTextEdt.Text := FReplaceText;
      FindTextEdt.OnChange := FindTextEdtChange;
      ReplaceTextEdt.OnChange := ReplaceTextEdtChange;
      FindBtn.OnClick := Find;
      ReplaceBtn.OnClick := Replace;
      ReplaceAllBtn.OnClick := ReplaceAll;
      CancelBtn.OnClick := Cansel;
      DialogStyle := Layout;
    end;
  end;
  Result := Assigned(FDialog);
  if Result then
  begin
    with FDialog do
    begin
      ActiveControl := FindTextEdt;
      FindTextEdt.SelectAll;
      Show;
    end;
    if Assigned(FOnShow) then FOnShow(Self);
  end;
end;

procedure TREFindDialog.CloseDialog;
begin
  if Assigned(FDialog) then
  begin
    FDialog.Close;
    if Assigned(FOnClose) then FOnClose(Self);
  end;
end;

{ TREReplaceDialog }

constructor TREReplaceDialog.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Layout := dsReplace;
end;

procedure Register;
begin
  RegisterComponents('Dialogs', [TREFindDialog]);
  RegisterComponents('Dialogs', [TREReplaceDialog]);
end;

end.

