(*	TVBRegexp

Ver, 1.00 2006/04/19 ^B
Ver, 1.01 2006/11/21 UsesRegexp ǉB
Ver, 1.02 2010/04/05 Delphi2010 ΉB
Ver, 1.03 2011/12/16 [[N̏CB
Ver, 1.04 2013/02/16 K\gpɕʂĂȂoȌCB
Ver, 1.05 2023/03/09 Delphi10.4 ɈڍsB뎚CBVBScript5.5 iIE5.5 ȍ~jɈڍsBTSubMatches, TVBRegexp.MultiLine ǉB
Ver, 1.06 2023/05/20 TVBRegexp.RegExecute CB

VBScript.Regexp Ver,5.5 gpK\CuB
ڍׂ MSDN QƁB

K\ňvB
TMatch
  property
    FirstIndex;	v̐擪ʒu([X^[g̃oCgP)B
    Length;		v̒(oCg)B
    Value;		vB

K\ňṽRNVB
TMatches
  property
    Count;		v̐B
    Items;		vB

K\B
TVBRegexp
  property
    Usable;		K\gp\Bs[hI[B
    UsesRegexp;	K\gpB
    Global;		ŜɓKpB
    IgnoreCase;	啶ʂȂB
    MultiLine; 𕡐sƂĈB
    Pattern;	p^[B
  method
    Execute;	B
    Replace;	uB
    Test;		B

ӎ
TMRegExp jbgJu܂@vɁB

	VBScript Regular Expression Library*)

unit VBRegexp;

interface

uses
  Winapi.Windows, System.SysUtils, System.Classes, System.Win.ComObj, Winapi.ActiveX;

type
  ERegexpException = class(Exception);  //VBScript.Regexp OB

  TSubMatches = class(TObject)
  private
    { Private 錾 }
    FSubMatchesList : TList;
    function GetCount: Integer;
    function GetItem(Index: Integer): string;
  protected
    { Protected 錾 }
    procedure Add(Value: string);
  public
    { Public 錾 }
    constructor Create;
    destructor Destroy; override;
    property Count: Integer read GetCount;
    property Items[Index: Integer]: string read GetItem; default;
  end;

  TMatch = class(TObject)
  private
    { Private 錾 }
    FFirstIndex: Integer;
    FLength: Integer;
    FValue: string;
    FSubMatches: TSubMatches;
  public
    { Public 錾 }
    constructor Create;
    destructor Destroy; override;
    property FirstIndex: Integer read FFirstIndex;
    property Length: Integer read FLength;
    property Value: string read FValue;
    property SubMatches: TSubMatches read FSubMatches;
  end;

  TMatches = class(TObject)
  private
    { Private 錾 }
    FMatchesList : TList;
    function GetCount: Integer;
    function GetItem(Index: Integer): TMatch;
  protected
    { Protected 錾 }
    procedure Add(Value: TMatch);
  public
    { Public 錾 }
    constructor Create;
    destructor Destroy; override;
    property Count: Integer read GetCount;
    property Items[Index: Integer]: TMatch read GetItem; default;
  end;

  TVBRegexp = class(TComponent)
  private
    { Private 錾 }
    FUsable: Boolean;
    FUsesRegexp: Boolean;
    FGlobal: Boolean;
    FIgnoreCase: Boolean;
    FMultiLine: Boolean;
    FPattern: string;
    FRegexpErrorMessage: string;
    FRegexpObject: Variant;
    procedure SetGlobal(Value: Boolean);
    procedure SetIgnoreCase(Value: Boolean);
    procedure SetMultiLine(Value: Boolean);
    procedure SetPattern(Value: string);
  protected
    { Protected 錾 }
    function RegExecute(const S: string): TMatches;
    function StrExecute(const S: string): TMatches;
    function RegReplace(const S, Substr: string): string;
    function StrReplace(const S, Substr: string): string;
    function RegTest(const S: string): Boolean;
    function StrTest(const S: string): Boolean;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Execute(const S: string): TMatches;
    function Replace(const S, Substr: string): string;
    function Test(const S: string): Boolean;
    property Usable: Boolean read FUsable;
  published
    { Published 錾 }
    property UsesRegexp: Boolean read FUsesRegexp write FUsesRegexp default True;
    property Global: Boolean read FGlobal write SetGlobal default True;
    property IgnoreCase: Boolean read FIgnoreCase write SetIgnoreCase default False;
    property MultiLine: Boolean read FMultiLine write SetMultiLine default False;
    property Pattern: string read FPattern write SetPattern;
  end;

procedure Register;

resourcestring
  SUnfindString = '"%s" ܂';

implementation

uses
  System.Variants;

{ TSubMatches }

function TSubMatches.GetCount: Integer;
begin
  Result := FSubMatchesList.Count;
end;

function TSubMatches.GetItem(Index: Integer): string;
begin
  Result := PString(FSubMatchesList.Items[Index])^;
end;

procedure TSubMatches.Add(Value: string);
var
  Buff: PString;
begin
  New(Buff);
  Buff^ := Value;
  FSubMatchesList.Add(Buff);
end;

constructor TSubMatches.Create;
begin
  inherited Create;

  FSubMatchesList := TList.Create;
end;

destructor TSubMatches.Destroy;
var
  i: Integer;
begin
  for i := FSubMatchesList.Count - 1 downto 0 do
    Dispose(PString(FSubMatchesList.Items[i]));
  FSubMatchesList.Free;

  inherited Destroy;
end;

{ TMatch }

constructor TMatch.Create;
begin
  inherited Create;

  FFirstIndex := -1;
  FLength := 0;
  FValue := '';
  FSubMatches := TSubMatches.Create;
end;

destructor TMatch.Destroy;
begin
  FSubMatches.Free;

  inherited Destroy;
end;

{ TMatches }

function TMatches.GetCount: Integer;
begin
  Result := FMatchesList.Count;
end;

function TMatches.GetItem(Index: Integer): TMatch;
begin
  Result := TMatch(FMatchesList.Items[Index]);
end;

constructor TMatches.Create;
begin
  inherited Create;

  FMatchesList := TList.Create;
end;

procedure TMatches.Add(Value: TMatch);
begin
  FMatchesList.Add(Value);
end;

destructor TMatches.Destroy;
var
  i: Integer;
begin
  for i:= FMatchesList.Count - 1 downto 0 do
    TMatch(FMatchesList.Items[i]).Free;
  FMatchesList.Free;

  inherited Destroy;
end;

{ TVBRegexp }

procedure TVBRegexp.SetGlobal(Value: Boolean);
begin
  if Value <> FGlobal then
  begin
    FGlobal := Value;
    if FUsable then
      FRegexpObject.Global := FGlobal;
  end;
end;

procedure TVBRegexp.SetIgnoreCase(Value: Boolean);
begin
  if Value <> FIgnoreCase then
  begin
    FIgnoreCase := Value;
    if FUsable then
      FRegexpObject.IgnoreCase := FIgnoreCase;
  end;
end;

procedure TVBRegexp.SetMultiLine(Value: Boolean);
begin
  if Value <> FMultiLine then
  begin
    FMultiLine := Value;
    if FUsable then
      FRegexpObject.MultiLine := FMultiLine;
  end;
end;

procedure TVBRegexp.SetPattern(Value: string);
begin
  if Value <> FPattern then
  begin
    FPattern := Value;
    if FUsable then
      FRegexpObject.Pattern := FPattern;
  end;
end;

function TVBRegexp.RegExecute(const S: string): TMatches;
var
  MatchesObject, MatchObject: Variant;
  Match: TMatch;
  i, j: Integer;
begin
  Result := TMatches.Create;
  try
    MatchesObject := FRegexpObject.Execute(S);
    try
      for i := 0 to MatchesObject.Count - 1 do
      begin
        MatchObject := MatchesObject.Item[i];
        try
          Match := TMatch.Create;
          //VBScript.Regexp ̓[n܂镶Ԃ悤B
          with Match do
          begin
            FValue := MatchObject.Value;
            FFirstIndex := MatchObject.FirstIndex;
            FLength := System.Length(FValue);
            for j := 0 to MatchObject.SubMatches.Count - 1 do
              FSubMatches.Add(MatchObject.SubMatches.Item[j]);
          end;
          Result.Add(Match);
        finally
          VarClear(MatchObject);
        end;
      end;
    finally
      VarClear(MatchesObject);
    end;
  except
    on E: EOleException do raise ERegexpException.Create(E.Message);
  end;
end;

function TVBRegexp.StrExecute(const S: string): TMatches;
var
  Substr, Temp: string;
  Hed, i: Integer;
  Mache: TMatch;
begin
  Result := TMatches.Create;
  if IgnoreCase then
  begin
    Substr := UpperCase(Pattern);
    Temp := UpperCase(S);
  end
  else
  begin
    Substr := Pattern;
    Temp := S;
  end;
  Hed := 0;
  i := Pos(Substr, Temp);
  while i > 0 do
  begin
    Mache := TMatch.Create;
    with Mache do
    begin
      FValue := Pattern;
      FFirstIndex := Hed + i - 1;
      FLength := System.Length(FValue);
    end;
    Result.Add(Mache);
    Temp := Copy(Temp, i + Length(Substr), Length(Temp));
    Hed := Mache.FirstIndex + Length(Substr);
    i := Pos(Pattern, Temp);
  end;
end;

function TVBRegexp.RegReplace(const S, Substr: string): string;
begin
  Result := S;
  try
    Result := FRegexpObject.Replace(S, Substr);
  except
    on E: EOleException do raise ERegexpException.Create(E.Message);
  end;
end;

function TVBRegexp.StrReplace(const S, Substr: string): string;
var
  Flags: TReplaceFlags;
begin
  Flags := [];
  if Global then
    Include(Flags, rfReplaceAll);
  if IgnoreCase then
    Include(Flags, rfIgnoreCase);
  Result := StringReplace(S, Pattern, Substr, Flags);
end;

function TVBRegexp.RegTest(const S: string): Boolean;
begin
  //! Result := False;
  try
    Result := FRegexpObject.Test(S);
  except
    on E: EOleException do raise ERegexpException.Create(E.Message);
  end;
end;

function TVBRegexp.StrTest(const S: string): Boolean;
var
  Substr, Temp: string;
begin
  if IgnoreCase then
  begin
    Substr := UpperCase(Pattern);
    Temp := UpperCase(S);
  end
  else
  begin
    Substr := Pattern;
    Temp := S;
  end;
  Result := Pos(Substr, Temp) > 0;
end;

constructor TVBRegexp.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FUsable := True;
  FUsesRegexp := True;
  FGlobal := True;
  FIgnoreCase := False;
  FMultiLine := False;
  FPattern := '';
  FRegexpErrorMessage := '';

  CoInitialize(nil);
  try
    FRegexpObject := CreateOleObject('VBScript.RegExp');
    FRegexpObject.Global := FGlobal;
    FRegexpObject.IgnoreCase := FIgnoreCase;
    FRegexpObject.Pattern := FPattern;
    FRegexpObject.MultiLine := FMultiLine;
  except
    on E: EOleError do
    begin
      FUsable := False;
      FUsesRegexp := False;
      FRegexpErrorMessage := E.Message;
    end;
  end;
end;

destructor TVBRegexp.Destroy;
begin
  if not VarIsEmpty(FRegexpObject) then
    VarClear(FRegexpObject);
  CoUninitialize;

  inherited Destroy;
end;

function TVBRegexp.Execute(const S: string): TMatches;
begin
  //! Result := TMaches.Create;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegExecute(S)
    else
      raise ERegexpException.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrExecute(S);
  end;
end;

function TVBRegexp.Replace(const S, Substr: string): string;
begin
  Result := S;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegReplace(S, Substr)
    else
      raise ERegexpException.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrReplace(S, Substr);
  end;
end;

function TVBRegexp.Test(const S: string): Boolean;
begin
  //! Result := False;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegTest(S)
    else
      raise ERegexpException.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrTest(S);
  end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TVBRegexp]);
end;

end.
